#!/bin/bash

cd $(dirname $0)/..

idea_home="$HOME/java/idea7"
bzrclient_home="../bzr-java-lib"

build_dir="$HOME/var/build/bzr4idea"

rm -rf $build_dir 2> /dev/null
mkdir -p $build_dir

find $idea_home/lib $bzrclient_home/lib  -type f -name "*jar" | tr "\n" ";" > $build_dir/.classpath
find src $bzrclient_home/src -type f -name "*java" > $build_dir/.sources

echo "Compiling..."
mkdir $build_dir/classes
javac -d $build_dir/classes -classpath @$build_dir/.classpath @$build_dir/.sources


function copy {
	mkdir -p $2 2> /dev/null
	tar c -C $1 . | tar x -C $2
}

echo "Building distribution package..."
copy $bzrclient_home/src/main/java $build_dir/classes
copy src $build_dir/classes
copy META-INF $build_dir/classes/META-INF

copy $bzrclient_home/lib $build_dir/bzr4idea/lib
find $build_dir/classes -type f -name "*java" | xargs rm
jar cf $build_dir/bzr4idea/lib/bzr4idea.jar -C $build_dir/classes .

cd $build_dir
zip -r bzr4idea.zip bzr4idea

echo "Done: $(ls -lh $build_dir/bzr4idea.zip)"


