package bzr4idea;

import com.intellij.openapi.vcs.annotate.AnnotationListener;
import com.intellij.openapi.vcs.annotate.FileAnnotation;
import com.intellij.openapi.vcs.annotate.LineAnnotationAspect;
import org.vcs.bazaar.client.IBazaarAnnotation;

public class BzrFileAnnotation implements FileAnnotation {

	IBazaarAnnotation annotation;

	private final LineAnnotationAspect DATE_ASPECT = new LineAnnotationAspect() {
		public String getValue(int lineNumber) {
			if (annotation.getNumberOfLines() == 0) {
				return "";
			} else {
				return annotation.getDate(lineNumber);
			}
		}
	};

	private final LineAnnotationAspect REVISION_ASPECT = new LineAnnotationAspect() {
		public String getValue(int lineNumber) {
			if (annotation.getNumberOfLines() == 0) {
				return "";
			} else {
				return annotation.getRevision(lineNumber);
			}
		}
	};

	private final LineAnnotationAspect AUTHOR_ASPECT = new LineAnnotationAspect() {
		public String getValue(int lineNumber) {
			if (annotation.getNumberOfLines() == 0) {
				return "";
			} else {
				return annotation.getAuthor(lineNumber);
			}
		}
	};

	private StringBuilder content = new StringBuilder();

	public BzrFileAnnotation(IBazaarAnnotation annotation) {
		this.annotation = annotation;
	}

	public void addListener(AnnotationListener listener) {
	}

	public void removeListener(AnnotationListener listener) {
	}

	public void dispose() {
	}

	public LineAnnotationAspect[] getAspects() {
		return new LineAnnotationAspect[]{REVISION_ASPECT, DATE_ASPECT, AUTHOR_ASPECT};
	}

	public String getToolTip(int lineNumber) {
		return String.format("Revision %s",
									annotation.getNumberOfLines() > 0 ? annotation.getRevision(0) : "?");
	}

	public String getAnnotatedContent() {
		return content.toString();
	}
}
