package bzr4idea;

import com.intellij.openapi.vcs.history.VcsRevisionNumber;
import org.vcs.bazaar.client.BazaarRevision;

public class BzrRevisionNumber implements VcsRevisionNumber {

	private BazaarRevision rev;

	public BzrRevisionNumber(BazaarRevision rev) {
		this.rev = rev;
	}

	public BazaarRevision getBazaarRevision() {
		return rev;
	}

	public String asString() {
		return rev.toString();
	}

	public int compareTo(VcsRevisionNumber o) {
		return rev.compareTo(BzrRevisionNumber.class.cast(o).rev);
	}
}
