package bzr4idea;

import com.intellij.openapi.components.PersistentStateComponent;
import com.intellij.openapi.components.ServiceManager;
import com.intellij.openapi.components.State;
import com.intellij.openapi.components.Storage;
import com.intellij.openapi.components.ApplicationComponent;
import com.intellij.util.xmlb.XmlSerializerUtil;
import org.jetbrains.annotations.NonNls;
import org.jetbrains.annotations.NotNull;

/**
 * @author Patrik Beno
 */
@State(
		name = "BzrApplicationSettings",
		storages = {@Storage(id = "BzrApplicationSettings", file = "$APP_CONFIG$/bzr4idea.xml")})
public class BzrVcsSettings implements PersistentStateComponent<BzrVcsSettings>, ApplicationComponent {

	protected String bzrExecutable = "bzr";

	public static BzrVcsSettings bzrApplicationSettings() {
		return ServiceManager.getService(BzrVcsSettings.class);
	}

	public BzrVcsSettings getState() {
		Log.info("BzrApplicationSettings.getState()");
		return this;
	}

	public void loadState(BzrVcsSettings settings) {
		Log.info("BzrApplicationSettings.loadState()");
		XmlSerializerUtil.copyBean(settings, this);
	}

	public String getBzrExecutable() {
		return bzrExecutable;
	}

	public void setBzrExecutable(String bzrexe) {
		this.bzrExecutable = bzrexe;
	}

	/// Component

	@NonNls
	@NotNull
	public String getComponentName() {
		return "Bazaar Configuration";
	}

	public void initComponent() {
	}

	public void disposeComponent() {
	}
}
