package bzr4idea;

import org.apache.log4j.Logger;

import java.util.Arrays;
import java.util.Formattable;
import java.util.Formatter;

/**
 * @author Patrik Beno
 */
public class Log {

	static private final Logger LOG = Logger.getLogger("bzr4idea");
	static private final Logger BZRLOG = Logger.getLogger("bzr");

	
	static public void info(final String msg, final Object... args) {
		LOG.info(new Object() {
			public String toString() {
				return String.format(msg, args);
			}
		});
	}

	static void bzr(final String ideacmd, final String dir, final String bzrcmd,
						 final Object... args) {
		LOG.info(new Object() {
			public String toString() {
				return String
						.format("bzr:%s : (%s) : bzr %s %s", ideacmd, dir, bzrcmd, Arrays.asList(args));
			}
		});
	}

	static public void bzrlog(String line) {
		BZRLOG.info(line);
	}


}
